﻿Imports System.Net
Imports System.Threading
Imports Microsoft.WindowsAzure
Imports Microsoft.WindowsAzure.Diagnostics
Imports Microsoft.WindowsAzure.ServiceRuntime
Imports Microsoft.WindowsAzure.StorageClient

Namespace WorkerRole1
    Public Class WorkerRole
        Inherits RoleEntryPoint
        Public Overrides Sub Run()
            ' This is a sample worker implementation. Replace with your logic.
            Trace.WriteLine("WorkerRole1 entry point called", "Information")

            Do
                Thread.Sleep(10000)
                Trace.WriteLine("Working", "Information")
            Loop
        End Sub

        Public StorageAccount As CloudStorageAccount = Nothing
        Public Overrides Function OnStart() As Boolean
            ' Set the maximum number of concurrent connections 
            ServicePointManager.DefaultConnectionLimit = 12

            DiagnosticMonitor.Start("DiagnosticsConnectionString")

            ' For information on handling configuration changes
            ' see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
            AddHandler RoleEnvironment.Changing, AddressOf RoleEnvironmentChanging

            'StorageAccount = New CloudStorageAccount(New StorageCredentialsAccountAndKey(
            '            "footlocker",
            '            "M9E2FVgXYF9x8UEkvTRTcERKcaF3QXpuJJdTKAH+l2pZQ7I66ZdJsRDyh//972pprDybSmgYXBQTQHZlt7b2nQ=="),
            '            New Uri("http://footlocker.blob.core.windows.net/"),
            '            New Uri("http://footlocker.queue.core.windows.net/"),
            '            New Uri("http://footlocker.table.core.windows.net/"))

            StorageAccount = CloudStorageAccount.FromConfigurationSetting("CloudStorage")

            'CreateAuthorTable()
            AddEntities()
            SelectEntities()
            Return MyBase.OnStart()
        End Function

        Private Sub RoleEnvironmentChanging(ByVal sender As Object, ByVal e As RoleEnvironmentChangingEventArgs)
            ' If a configuration setting is changing
            If e.Changes.Any(Function(change) TypeOf change Is RoleEnvironmentConfigurationSettingChange) Then
                ' Set e.Cancel to true to restart this role instance
                e.Cancel = True
            End If
        End Sub

        Public Sub CreateAuthorTable()


            'Dim StorageAccount As New CloudStorageAccount(New StorageCredentialsAccountAndKey(
            '        "devstoreaccount1",
            '        "Eby8vdM02xNOcqFlqUwJPLlmEtlCDXJ1OUzFT50uSRZ6IFsuFq2UVErCz4I6tq/K1SZFPTOtr/KBHBeksoGMGw=="),
            '        New Uri("http://127.0.0.1:10000/ "),
            '        New Uri("http://127.0.0.1:10001/ "),
            '        New Uri("http://127.0.0.1:10002/ "))


            Dim TableClient = StorageAccount.CreateCloudTableClient()

            Dim tableList As IEnumerable(Of String) = TableClient.ListTables()
            For Each tableName As String In tableList
                Debug.WriteLine(tableName)
            Next tableName
            TableClient.CreateTableIfNotExist("Authors")

        End Sub

        Public Sub AddEntities()
            Dim TableClient = StorageAccount.CreateCloudTableClient()

            Dim author As New TableStorageAuthor()
            author.FirstName = "Joseph"
            author.LastName = "Fultz"
            author.RowKey = Guid.NewGuid().ToString()
            author.Id = author.RowKey
            author.State = "TX"
            author.PartitionKey = "TX"

            Dim ctx As New AuthorDataServiceContext(StorageAccount.TableEndpoint, StorageAccount.Credentials)
            ctx.Add(author)
        End Sub

        Public Sub SelectEntities()
            Dim ctx As New AuthorDataServiceContext(StorageAccount.TableEndpoint, StorageAccount.Credentials)

            Dim authors = _
                From a In ctx.AuthorData _
                Select a

            For Each ta As TableStorageAuthor In authors
                Debug.WriteLine(ta.FirstName & " " & ta.LastName)
            Next ta
        End Sub
    End Class
End Namespace
